Subject: Re: [PATCH] powerpc: Add preempt lazy support

From: Michael Ellerman <[email-masked]>
Date: Thu, 14 Nov 2024 13:01:29 +1100

Shrikanth Hegde <[email-masked]> writes:
> Thank you Sebastian for taking a look and rwb tag.
>
>> On 2024-11-08 15:48:53 [+0530], Shrikanth Hegde wrote:
>>> Define preempt lazy bit for Powerpc. Use bit 9 which is free and within
>>> 16 bit range of NEED_RESCHED, so compiler can issue single andi.
>>>
>>> Since Powerpc doesn't use the generic entry/exit, add lazy check at exit
>>> to user. CONFIG_PREEMPTION is defined for lazy/full/rt so use it for
>>> return to kernel.
>>>
>>> Ran a few benchmarks and db workload on Power10. Performance is close to
>>> preempt=none/voluntary. It is possible that some patterns would
>>> differ in lazy[2]. More details of preempt lazy is here [1]
>>>
>>> Since Powerpc system can have large core count and large memory,
>>> preempt lazy is going to be helpful in avoiding soft lockup issues.
>>>
>>> [1]: https://lore.kernel.org/lkml/[email-masked]/
>>> [2]: https://lore.kernel.org/all/[email-masked]/
>> 
>> The lazy bits are only in tip.
>
> Hi Michael, I sent it to powerpc tree since all the changes were in 
> arch/powerpc. Please let me know if i have send it to tip tree instead.

I think I'd like it to have a full cycle of testing in next before going
into mainline. So I'll plan to take this via the powerpc tree for the
next cycle.

I assume you haven't tested 32-bit at all?

cheers